Bug 746761 - Review Request: mongo-java-driver - A Java driver for MongoDB
Summary: Review Request: mongo-java-driver - A Java driver for MongoDB
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Alexander Kurtakov
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-10-17 17:42 UTC by Jon VanAlten
Modified: 2015-07-13 04:43 UTC (History)
4 users (show)

Fixed In Version: mongo-java-driver-2.6.5-2.fc15
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-12-13 21:51:48 UTC
akurtako: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jon VanAlten 2011-10-17 17:42:21 UTC
Spec URL: http://www.vanaltj.com/pkgreview/mongo-java-driver.spec
SRPM URL: http://www.vanaltj.com/pkgreview/mongo-java-driver-2.6.5-1.fc15.src.rpm
Description: This is the java driver for MongoDB.  Also included as subpackage is BSON implementation (the source is distributed along with the driver itself) which could in essence be used by other Java applications.

This is my first attempt at packaging software for Fedora.  I am looking to get sponsored into packagers group.  Please show no mercy in telling me what I have done wrong ;)

Comment 1 Alexander Kurtakov 2011-10-29 14:29:03 UTC
I'll do this one.

Comment 2 Alexander Kurtakov 2011-11-02 12:26:45 UTC
Package Review
==============

Key:
- = N/A
x = Check
! = Problem
? = Not evaluated

=== REQUIRED ITEMS ===
[!]  Rpmlint output:
mongo-java-driver.noarch: W: incoherent-version-in-changelog 2.6.5 ['2.6.5-1.fc15', '2.6.5-1']
Please fix.
mongo-java-driver.noarch: W: no-documentation
mongo-java-driver-bson.noarch: W: no-documentation
At least LICENSE.txt has to be installed as doc.
mongo-java-driver-bson-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
mongo-java-driver-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados

[x]  Package is named according to the Package Naming Guidelines[1].
[x]  Spec file name must match the base package name, in the format %{name}.spec.
[x]  Package meets the Packaging Guidelines[2].
[x]  Package successfully compiles and builds into binary rpms.
[x]  Buildroot definition is not present
[x]  Package is licensed with an open-source compatible license and meets other legal requirements as defined in the legal section of Packaging Guidelines[3,4].
[x]  License field in the package spec file matches the actual license.
License type: ASL 2.0
[!]  If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package is included in %doc.
[!]  All independent sub-packages have license of their own
[x]  Spec file is legible and written in American English.
[x]  Sources used to build the package matches the upstream source, as provided in the spec URL.
[x]  All build dependencies are listed in BuildRequires, except for any that are listed in the exceptions section of Packaging Guidelines[5].
[x]  Package must own all directories that it creates or must require other packages for directories it uses.
[x]  Package does not contain duplicates in %files.
[x]  File sections do not contain %defattr(-,root,root,-) unless changed with good reason
[x]  Permissions on files are set properly.
[x]  Package does NOT have a %clean section which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). (not needed anymore)
[x]  Package consistently uses macros (no %{buildroot} and $RPM_BUILD_ROOT mixing)
[x]  Package contains code, or permissable content.
[x]  Fully versioned dependency in subpackages, if present.
[-]  Package contains a properly installed %{name}.desktop file if it is a GUI application.
[x]  Package does not own files or directories owned by other packages.
[x]  Javadoc documentation files are generated and included in -javadoc subpackage
[x]  Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlinks)
[x]  Packages have proper BuildRequires/Requires on jpackage-utils
[x]  Javadoc subpackages have Require: jpackage-utils
[x]  Package uses %global not %define
[-]  If package uses tarball from VCS include comment how to re-create that tarball (svn export URL, git clone URL, ...)
[x]  If source tarball includes bundled jar/class files these need to be removed prior to building
[x ]  All filenames in rpm packages must be valid UTF-8.
[x]  Jar files are installed to %{_javadir}/%{name}.jar (see [6] for details)
[-]  If package contains pom.xml files install it (including depmaps) even when building with ant
[-]  pom files has correct add_maven_depmap

=== Maven ===
[-]  Use %{_mavenpomdir} macro for placing pom files instead of %{_datadir}/maven2/poms
[-]  If package uses "-Dmaven.test.skip=true" explain why it was needed in a comment
[-]  If package uses custom depmap "-Dmaven.local.depmap.file=*" explain why it's needed in a comment
[-]  Package DOES NOT use %update_maven_depmap in %post/%postun
[-]  Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-utils for %update_maven_depmap macro

=== Other suggestions ===
[x]  If possible use upstream build method (maven/ant/javac)
[x]  Avoid having BuildRequires on exact NVR unless necessary
[x]  Package has BuildArch: noarch (if possible)
[x]  Latest version is packaged.


=== Issues ===
1. Install License file.
2. fix changelog
3. there is no need to specify noarch for every subpackage if the main one is noarch
4. instead of cd and cp to/from mongodb-mongo-java-driver-ffe0029 it would be nice to use %setup -q -n mongodb-mongo-java-driver-ffe0029 and effectively make it the buildroot
5. The two javadoc subpackages are broken because you don't have index and all the rest of the file that make them browsable. Unless you can make the javadoc be generated for the two subpackages in two different directories with all the harness files you would have to create one single javadoc subpackage merging the two current one.

Comment 3 Jon VanAlten 2011-11-07 23:57:41 UTC
(In reply to comment #2)

Thanks for the review!

> === Issues ===
> 1. Install License file.

Whoops!  I have ensured that both main and -bson, -javadoc subpackages (since there is no dependency) install the LICENSE.txt file.  I also added the README.md, for good measure.

> 2. fix changelog

Done.

> 3. there is no need to specify noarch for every subpackage if the main one is
> noarch

Oh.  That's great, have stripped relevant unnecessary lines from .spec.

> 4. instead of cd and cp to/from mongodb-mongo-java-driver-ffe0029 it would be
> nice to use %setup -q -n mongodb-mongo-java-driver-ffe0029 and effectively make
> it the buildroot

Good idea, thanks.

> 5. The two javadoc subpackages are broken because you don't have index and all
> the rest of the file that make them browsable. Unless you can make the javadoc
> be generated for the two subpackages in two different directories with all the
> harness files you would have to create one single javadoc subpackage merging
> the two current one.

So true, careless on my part.  I looked into what it would take to generate harness for each part, would need to change upstream build (which I am loath to do).  So, have combined into single javadoc, for the time being.  Upstream has hinted that they would like to change so that the bson part is more separate anyways, so in the longer term I will find out more about that.

I've put updated files in same location:

Spec URL: http://www.vanaltj.com/pkgreview/mongo-java-driver.spec
SRPM URL:
http://www.vanaltj.com/pkgreview/mongo-java-driver-2.6.5-1.fc15.src.rpm

Comment 4 Alexander Kurtakov 2011-11-08 06:52:52 UTC
Please note that you're supposed to add changelog entries everytime you change smth. But this is not a blocker so 

APPROVED

Comment 5 Alexander Kurtakov 2011-11-08 06:56:20 UTC
Jon, 
Please sign the contributor agreement in FAS, I will sponsor you only after you do this.

Comment 6 Jon VanAlten 2011-11-08 18:57:30 UTC
(In reply to comment #5)
Alex,
Thanks again, and I will be sure to put changelog entries for any future changes.  My account in FAS shows CLA signed.

Comment 7 Jon VanAlten 2011-11-08 22:16:29 UTC
New Package SCM Request
=======================
Package Name: mongo-java-driver
Short Description: A Java driver for MongoDB
Owners: jvanalte
Branches: f15 f16
InitialCC:

Comment 8 Gwyn Ciesla 2011-11-09 13:24:19 UTC
Git done (by process-git-requests).

Comment 9 Fedora Update System 2011-11-30 01:20:08 UTC
mongo-java-driver-2.6.5-2.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/mongo-java-driver-2.6.5-2.fc15

Comment 10 Fedora Update System 2011-11-30 01:23:58 UTC
mongo-java-driver-2.6.5-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/mongo-java-driver-2.6.5-2.fc16

Comment 11 Fedora Update System 2011-12-02 21:31:53 UTC
mongo-java-driver-2.6.5-2.fc15 has been pushed to the Fedora 15 testing repository.

Comment 12 Fedora Update System 2011-12-13 21:51:48 UTC
mongo-java-driver-2.6.5-2.fc15 has been pushed to the Fedora 15 stable repository.

Comment 13 Fedora Update System 2011-12-13 21:56:54 UTC
mongo-java-driver-2.6.5-2.fc16 has been pushed to the Fedora 16 stable repository.


Note You need to log in before you can comment on or make changes to this bug.